unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges;

type
  TForm1 = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    OpenButton: TButton;
    PickOutButton: TButton;
    Memo: TMemo;
    SaveButton: TButton;
    ExitButton: TButton;
    Gauge: TGauge;
    StartTypeComboBox: TComboBox;
    Label1: TLabel;
    ReloadButton: TButton;
    procedure OpenButtonClick(Sender: TObject);
    procedure PickOutButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ReloadButtonClick(Sender: TObject);
  private
    OldLines: TStringList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  StartTypeComboBox.ItemIndex := 0;
  OldLines := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  OldLines.Free;
end;

procedure TForm1.OpenButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then with OpenDialog, Memo do begin
    Lines.LoadFromFile(FileName);
    OldLines.Assign(Lines);
  end;
  StartTypeComboBox.Enabled := TRUE;
  PickOutButton.Enabled := TRUE;
  ReloadButton.Enabled := TRUE;
  SaveButton.Enabled := TRUE;
  Gauge.Progress := 0;
end;

procedure TForm1.PickOutButtonClick(Sender: TObject);
var
  i,c: integer;
  sl: TStringList;
  s: string;
  SP: boolean; // StringsPresent
  st: char; // StartType

  procedure ClearDummyLines;
  begin
    if not SP then begin
      while (sl.Count > 1) and (sl[sl.Count - 1] <> '') do sl.Delete(sl.Count - 1);
      if (sl.Count > 1) and (sl[sl.Count - 1] = '') then sl.Delete(sl.Count - 1);
    end;
  end;

begin
  sl := TStringList.Create;
  st := IntToStr(StartTypeComboBox.ItemIndex)[1];
  with Memo do begin
    c := Lines.Count - 1;
    if c < 1 then begin
      Application.MessageBox('  !','Truncate error',MB_OK);
      Exit;
    end;
    if Trim(Lines[0]) <> 'REGEDIT4' then begin
      Application.MessageBox('  !','Truncate error',MB_OK);
      end
    else sl.Add(Lines[0]);
    SP := TRUE;
    for i := 1 to c do begin
      s := Trim(Lines[i]);
      Gauge.Progress := Trunc(i/c*99.8);
      //   
      if Length(s) > 0 then begin
        if s[1] = '[' then begin
          //     - 
          ClearDummyLines;
          SP := FALSE;
          sl.Add('');
          sl.Add(s);
          end
        else if (Copy(s,1,7) = '"Group"') or (Copy(s,1,13) = '"DisplayName"') then sl.Add(s)
        else if (Copy(s,1,7) = '"Start"') then begin
          sl.Add(s);
          if Copy(s,Length(s),1) = st then SP := TRUE;
        end;
      end;
    end;
    ClearDummyLines;
    Lines.Clear;
    Lines.Assign(sl);
  end;
  sl.Free;
  Gauge.Progress := 100;
  PickOutButton.Enabled := FALSE;
  StartTypeComboBox.Enabled := FALSE;
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
var
  s: string;
begin
  if SaveDialog.Execute then with SaveDialog, Memo do begin
    s := FileName;
    if Pos('.reg',s) = 0 then s := s + '.reg';
    Lines.SaveToFile(s);
  end;
end;

procedure TForm1.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ReloadButtonClick(Sender: TObject);
begin
  Gauge.Progress := 50;
  Memo.Lines.Assign(OldLines);
  PickOutButton.Enabled := TRUE;
  StartTypeComboBox.Enabled := TRUE;
  Gauge.Progress := 0;
end;

end.
